// ATLtermo.h : Declaration of the CATLtermo

#ifndef __ATLTERMO_H_
#define __ATLTERMO_H_

#include "resource.h"       // main symbols
#include <atlhost.h>

/////////////////////////////////////////////////////////////////////////////
// CATLtermo





class CATLtermo : 
	public CAxDialogImpl<CATLtermo>
{
public:
	// Zmienne zadeklarowane w klasie kontrolki:
	SOCKET sock_server, sock_data;
	sockaddr_in saSockAddr;
	hostent* lpHostEnt;
	HANDLE hThread;
	//char m_server[100]="153.19.211.2";  
	//long m_port=7777;         
	
	
	static DWORD WINAPI ConnectThread(void* obj)
	{
		char buff_recv[2000];
		CATLtermo* mg_obj = (CATLtermo*) obj;
		int err = connect(mg_obj->sock_data, (sockaddr*) &mg_obj->saSockAddr, sizeof(sockaddr));
		if(err == SOCKET_ERROR) {
			closesocket(mg_obj->sock_data);
			mg_obj->MessageBox("Nie udao si nawiza poczenia z serwerem.");
			DWORD exCode;
			if(GetExitCodeThread(mg_obj->hThread, &exCode)) ExitThread(exCode);
			mg_obj->hThread = NULL;
			return 0;
		};
		char buff[200];
		//lstrcpy(buff, "Jeste po-czony z ");
		//lstrcat(buff, mg_obj->m_server);
		mg_obj->SetDlgItemText(IDC_VIEW, buff);
		while(TRUE) { 
			if(recv(mg_obj->sock_data, buff_recv, 2000, 0) > 0) mg_obj->ViewText(buff_recv);
			Sleep(500);
		};
		return 1;
	}


	CATLtermo()
	{
	}

	~CATLtermo()
	{
	}

	enum { IDD = IDD_ATLTERMO };

BEGIN_MSG_MAP(CATLtermo)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	COMMAND_ID_HANDLER(IDOK, OnOK)
	COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
	COMMAND_HANDLER(IDC_ABOUT, BN_CLICKED, OnClickedAbout)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);
	
	void ViewText(char* buff_recv)
	{
	HWND editHwnd = GetDlgItem(IDC_VIEW);
	//	wsprintf (buffer, "%s\r\n%s", buff_temp, buff_recv);
	::SetWindowText(editHwnd, buff_recv);
	}
	
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		char m_server[100]="153.19.211.2";  
		long m_port=7777;  
		WSADATA wsaData;
		DWORD ThreadId;

		if(WSAStartup(MAKEWORD(2,2), &wsaData)) {
			MessageBox("Nieudana inicjalizacja biblioteki WinSocks");
			return 0;
		};
		if(sock_server != INVALID_SOCKET) closesocket(sock_server);
		if(sock_data != INVALID_SOCKET) closesocket(sock_data);

		// czenie ze zdalnym serwerem
			sock_server = INVALID_SOCKET;
			sock_data = socket (PF_INET, SOCK_STREAM, IPPROTO_TCP);
			if(sock_data == INVALID_SOCKET) {
				MessageBox("Bd funkcji socket");
				return 0;
			};
			memset(&saSockAddr, 0, sizeof(sockaddr_in));
			saSockAddr.sin_family = AF_INET;
			saSockAddr.sin_port = htons(WORD(m_port));
			lpHostEnt = gethostbyname(m_server);
			if(!lpHostEnt) {
				closesocket(sock_server);
				sock_server = INVALID_SOCKET;
				MessageBox("Bd funkcji gethostbyname");
				return 0;
			};
			memcpy (&saSockAddr.sin_addr.s_addr, lpHostEnt->h_addr, lpHostEnt->h_length);
			hThread = CreateThread(NULL, 0, ConnectThread, this, 0, &ThreadId);
		return 1;  // Let the system set the focus
	}

	LRESULT OnOK(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		EndDialog(wID);
		return 0;
	}

	LRESULT OnCancel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		EndDialog(wID);
		return 0;
	}
	LRESULT OnClickedAbout(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
	{
		MessageBox("ATL termometr\naplikacja klienta telemetrycznego termometru\nOstry 2005");
		return 0;
	}
	LRESULT OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// TODO : Add Code for message handler. Call DefWindowProc if necessary.
		return 0;
	}

	
};





#endif //__ATLTERMO_H_
